﻿Imports System
Imports System.IO
Imports System.Windows
Imports System.Windows.Media
Imports System.Windows.Media.Imaging
Imports System.Windows.Navigation
Imports Microsoft.Phone.Controls
Imports Microsoft.Xna.Framework.Media

Partial Public Class MainPage
    Inherits PhoneApplicationPage
    Private captureSource As CaptureSource

    Public Sub New()
        InitializeComponent()

        Dim videoCaptureDevice As VideoCaptureDevice = CaptureDeviceConfiguration.GetDefaultVideoCaptureDevice()
        videoCaptureDevice.DesiredFormat = New VideoFormat(PixelFormatType.Format32bppArgb, 640, 480, 30)
        captureSource = New CaptureSource With {.VideoCaptureDevice = videoCaptureDevice}

        Dim bitmap As New WriteableBitmap(105, 480)
        Dim imgBrush As ImageBrush = New ImageBrush With {.ImageSource = bitmap}
        rect1.Fill = imgBrush
        rect2.Fill = imgBrush
        rect3.Fill = imgBrush
        rect4.Fill = imgBrush
        rect5.Fill = imgBrush
        rect6.Fill = imgBrush

        'Dim sink As New KaleidoscopeVideoSink(bitmap) With {.AllocationMode = SampleAllocationMode.ReuseBuffer, .CaptureSource = captureSource}
        Dim sink As New KaleidoscopeVideoSink(bitmap)
        sink.AllocationMode = SampleAllocationMode.ReuseBuffer
        sink.CaptureSource = captureSource
    End Sub

    Protected Overrides Sub OnNavigatedTo(ByVal args As NavigationEventArgs)
        If captureSource IsNot Nothing AndAlso CaptureDeviceConfiguration.AllowedDeviceAccess Then
            captureSource.Start()
            startButton.Visibility = Visibility.Collapsed
        End If

        MyBase.OnNavigatedTo(args)
    End Sub

    Protected Overrides Sub OnNavigatedFrom(ByVal args As NavigationEventArgs)
        If captureSource IsNot Nothing AndAlso captureSource.State = CaptureState.Started Then
            captureSource.Stop()
            startButton.Visibility = Visibility.Visible
        End If

        MyBase.OnNavigatedFrom(args)
    End Sub

    Private Sub OnStartButtonClick(ByVal sender As Object, ByVal args As RoutedEventArgs)
        If captureSource IsNot Nothing AndAlso (CaptureDeviceConfiguration.AllowedDeviceAccess OrElse CaptureDeviceConfiguration.RequestDeviceAccess()) Then
            captureSource.Start()
            startButton.Visibility = Visibility.Collapsed
        End If
    End Sub

    Private Sub OnAppBarCaptureButtonClick(ByVal sender As Object, ByVal args As EventArgs)
        saveStoryboard.Begin()
        Dim captureBitmap As New WriteableBitmap(imgPanel, Nothing)
        Dim dt As Date = Date.Now
        Dim filename As String = String.Format("kaleidovideo-{0:D2}-{1:D2}-{2:D2}-{3:D2}-{4:D2}-{5:D2}", dt.Year Mod 100, dt.Month, dt.Day, dt.Hour, dt.Minute, dt.Second)
        Dim memoryStream As New MemoryStream()
        captureBitmap.SaveJpeg(memoryStream, captureBitmap.PixelWidth, captureBitmap.PixelHeight, 0, 80)
        memoryStream.Position = 0
        Dim mediaLibrary As New MediaLibrary()
        mediaLibrary.SavePicture(filename, memoryStream)
    End Sub
End Class