﻿Imports System.Windows
Imports System.Windows.Media
Imports System.Windows.Navigation
Imports Microsoft.Phone.Controls

Partial Public Class MainPage
    Inherits PhoneApplicationPage
    Private captureSource As CaptureSource

    Public Sub New()
        InitializeComponent()

        captureSource = New CaptureSource With {.VideoCaptureDevice = CaptureDeviceConfiguration.GetDefaultVideoCaptureDevice()}
    End Sub

    Protected Overrides Sub OnNavigatedTo(ByVal args As NavigationEventArgs)
        If captureSource IsNot Nothing AndAlso CaptureDeviceConfiguration.AllowedDeviceAccess Then
            VideoBrush.SetSource(captureSource)
            captureSource.Start()
            startButton.Visibility = Visibility.Collapsed
        End If
        MyBase.OnNavigatedTo(args)
    End Sub

    Protected Overrides Sub OnNavigatedFrom(ByVal args As NavigationEventArgs)
        If captureSource IsNot Nothing AndAlso captureSource.State = CaptureState.Started Then
            captureSource.Stop()
            startButton.Visibility = Visibility.Visible
        End If
        MyBase.OnNavigatedFrom(args)
    End Sub

    Private Sub OnStartButtonClick(ByVal sender As Object, ByVal args As RoutedEventArgs)
        If captureSource IsNot Nothing AndAlso (CaptureDeviceConfiguration.AllowedDeviceAccess OrElse CaptureDeviceConfiguration.RequestDeviceAccess()) Then
            VideoBrush.SetSource(captureSource)
            captureSource.Start()
            startButton.Visibility = Visibility.Collapsed
        End If
    End Sub
End Class