﻿Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Net
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Documents
Imports System.Windows.Input
Imports System.Windows.Media
Imports System.Windows.Media.Animation
Imports System.Windows.Media.Imaging
Imports System.Windows.Navigation
Imports System.Windows.Shapes
Imports Microsoft.Phone.Controls

Partial Public Class MainPage
    Inherits PhoneApplicationPage
    Private _captureSource As CaptureSource

    Public Sub New()
        InitializeComponent()

        Dim videoCaptureDevice As VideoCaptureDevice = CaptureDeviceConfiguration.GetDefaultVideoCaptureDevice()

        If videoCaptureDevice IsNot Nothing Then
            videoCaptureDevice.DesiredFormat = New VideoFormat(PixelFormatType.Format8bppGrayscale, 0, 0, 0)
        End If

        _captureSource = New CaptureSource With {.VideoCaptureDevice = videoCaptureDevice}

        Dim videoSink As New SimpleVideoSink(Sub(bitmap As WriteableBitmap) img.Source = bitmap) With {.CaptureSource = _captureSource, .AllocationMode = SampleAllocationMode.ReuseBuffer}
    End Sub

    Protected Overrides Sub OnNavigatedTo(ByVal args As NavigationEventArgs)
        If _captureSource IsNot Nothing AndAlso CaptureDeviceConfiguration.AllowedDeviceAccess Then
            _captureSource.Start()
            startButton.Visibility = Visibility.Collapsed
        End If
        MyBase.OnNavigatedTo(args)
    End Sub

    Protected Overrides Sub OnNavigatedFrom(ByVal args As NavigationEventArgs)
        If _captureSource IsNot Nothing AndAlso _captureSource.State = CaptureState.Started Then
            _captureSource.Stop()
            startButton.Visibility = Visibility.Visible
        End If
        MyBase.OnNavigatedFrom(args)
    End Sub

    Private Sub OnStartButtonClick(ByVal sender As Object, ByVal args As RoutedEventArgs)
        If _captureSource IsNot Nothing AndAlso (CaptureDeviceConfiguration.AllowedDeviceAccess OrElse CaptureDeviceConfiguration.RequestDeviceAccess()) Then
            _captureSource.Start()
            startButton.Visibility = Visibility.Collapsed
        End If
    End Sub

    Private Sub OnAppBarToggleButtonClick(ByVal sender As Object, ByVal args As EventArgs)
        If _captureSource IsNot Nothing AndAlso _captureSource.VideoCaptureDevice IsNot Nothing Then
            _captureSource.Stop()

            If _captureSource.VideoCaptureDevice.DesiredFormat.PixelFormat = PixelFormatType.Format8bppGrayscale Then
                _captureSource.VideoCaptureDevice.DesiredFormat = New VideoFormat(PixelFormatType.Format32bppArgb, 0, 0, 0)
            Else
                _captureSource.VideoCaptureDevice.DesiredFormat = New VideoFormat(PixelFormatType.Format8bppGrayscale, 0, 0, 0)
            End If

            _captureSource.Start()
        End If
    End Sub
End Class