﻿Imports Microsoft.VisualBasic
Imports System
Imports System.Windows.Media
Imports System.Windows.Media.Imaging

Public Class SimpleVideoSink
    Inherits VideoSink
    Private videoFormat As VideoFormat
    Private writeableBitmap As WriteableBitmap
    Private action As Action(Of WriteableBitmap)

    Public Sub New(ByVal action As Action(Of WriteableBitmap))
        Me.action = action
    End Sub

    Protected Overrides Sub OnCaptureStarted()
    End Sub

    Protected Overrides Sub OnCaptureStopped()
    End Sub

    Protected Overrides Sub OnFormatChange(ByVal videoFormat As VideoFormat)
        Me.videoFormat = videoFormat

        System.Windows.Deployment.Current.Dispatcher.BeginInvoke(Sub()
                                                                     writeableBitmap = New WriteableBitmap(videoFormat.PixelWidth, videoFormat.PixelHeight)
                                                                     action(writeableBitmap)
                                                                 End Sub)
    End Sub

    Protected Overrides Sub OnSample(ByVal sampleTimeInHundredNanoseconds As Long, ByVal frameDurationInHundredNanoseconds As Long, ByVal sampleData() As Byte)
        If writeableBitmap Is Nothing Then
            Return
        End If

        Dim baseIndex As Integer = 0

        For row As Integer = 0 To writeableBitmap.PixelHeight - 1
            For col As Integer = 0 To writeableBitmap.PixelWidth - 1
                Dim pixel As Integer = 0

                If videoFormat.PixelFormat = PixelFormatType.Format8bppGrayscale Then
                    Dim grayShade As Byte = sampleData(baseIndex + col)
                    pixel = CInt(Fix(grayShade)) Or (grayShade << 8) Or (grayShade << 16) Or (&HFF << 24)
                Else
                    Dim index As Integer = baseIndex + 4 * col
                    pixel = CInt(Fix(sampleData(index + 0))) Or (sampleData(index + 1) << 8) Or (sampleData(index + 2) << 16) Or (sampleData(index + 3) << 24)
                End If
                writeableBitmap.Pixels(row * writeableBitmap.PixelWidth + col) = pixel
            Next col
            baseIndex += videoFormat.Stride
        Next row
        writeableBitmap.Dispatcher.BeginInvoke(Sub() writeableBitmap.Invalidate())
    End Sub
End Class